#!/usr/bin/perl
#
# Envirolyzer version 1.22 by Craig Richards
# January 01, 2003
# check for updates at
# http://www.CraigRichards.com/software/
# 
# 
# # # # # # # # # # # # # # # #
# 
# INSTALLATION INSTRUCTIONS - PLEASE READ
#
# You may need to change the server's path to Perl (above)
# A good alternate line is  #!/usr/local/bin/perl
# Use whatever is at the top of any existing (working) scripts 
# on your server.
#
# You may change the extension to ".pl" if ".cgi" is not 
# supported by your server.
#
# Envirolyzer is a Perl 5 script that identifies your server's
# environmental variables and reports them in your browser.
# 
# Simply upload this file (as ASCII text) to any path 
# in your domain or at its root. If your server administrator 
# restricts executables to a cgi or cgi-bin directory, 
# that's where you'd want to put the envirolyzer.cgi file.
# 
# On Unix/Linux and perhaps other servers, set the 
# file permissions for the envirolyzer.cgi document to 
# 755 (world executable or rwxr-xr-x).
# 
# That's it! Now open your browser and type:
# http://www.mydomainhere.com/path/envirolyzer.cgi
#            ^                ^   your domain and path go here)
# 
# # # # # # # # # # # # # # # #
# 
# WHEN YOU USE Envirolyzer
# YOU AGREE WITH THESE TERMS AND CONDITIONS
#
# We encourage your feedback and suggestions; however, 
# Envirolyzer is distributed as "freeware" (no license fee is 
# collected) so user support is not available. User agrees to 
# run this application at his/her own risk, assumes all 
# liability, and no warranty as to the suitability or 
# performance of Envirolyzer for your specific purpose is 
# stated nor implied. If dissatisfied with Envirolyzer, 
# discontinue use.
#
# Envirolyzer may be freely distributed via the Internet or 
# included on CD-ROM as long as the original source code, 
# comments, instructions and credits remain intact. 
# Envirolyzer is free and may not be individually sold 
# though it may be bundled with other software whether 
# that distribution contains other software that is free, 
# shareware, demo or sold. In essence, no one should 
# materially profit from distribution of this script.
#
# You are urged not to link to this script from any public 
# pages on your site as the information reported about your 
# site by Envirolyzer may compromise the security of your site 
# and/or server.
# 
# Application and interface is (c)Copyright 2003. 
# All rights reserved worldwide.
# 
# If you like this environment analyzing tool, let me know. 
# Go to http://www.CraigRichards.com/software/ for upgrade info 
# as it becomes available.
#
# Feel free to email me at "CGI@CraigRichards.com" with your 
# comments and/or suggestions.
#
# # # # # # # # # # # # # # # #
#### 
#### USER-MODIFIABLE VARIABLES
   # 
#--> input your static IP address here:
   # note: for multiple administrators, just duplicate 
   # the line below to add more static IP addresses.
   #
   $ipaddress .= "000.000.000.000\n"; # your IP goes here
   $ipaddress .= "000.000.000.000\n"; # add another (and so on)...

if (-e "iplock.txt"){
 open(IP,"iplock.txt");
 $ipaddress.=<IP>;
 close(IP);
}
   #
#--> set access-restriction security feature below
   #    - only if you use a static IP address -
   #
   $secure=0; 
   #       ^ Set to 1 to enable IP address security.
   #
#--> set display color values below
   #
   $c1="#7F007F"; # heads & borders
   $c2="#000000"; # subtle color
   $c3="#E0E0E0"; # table background color
   $c4="#EDEDED"; # prompt background color
   $c5="#FFFFFF"; # result background color
   $c6="#000000"; # overall interface background color
   $c7="#FFCC66"; # mouseover highlight color (CCS)
   $face="arial,verdana,helvetica,sans-serif"; # font set
   #
####
# # # # # # # # # # # # # # # # # # # # # # # #
# # # # # # # # # # # # # # # # # # # # # # # #
#                                           # #
# DO NOT CHANGE ANYTHING BELOW THIS POINT!  # #
#                                           # #
# # # # # # # # # # # # # # # # # # # # # # # #
# # # # # # # # # # # # # # # # # # # # # # # #
#
##########
# VARIABLES DEFINED

$fnt="<FONT SIZE=2 FACE=$face>";
$fnt1="<FONT SIZE=1 FACE=$face>";
$v="1.22";
$version="v $v";
$secflag="<NOBR>not restricted<BR>\nuser IP:&nbsp;$ENV{REMOTE_ADDR}</NOBR>";
$row="<TR VALIGN=TOP><TD BGCOLOR=$c4 ALIGN=RIGHT NOWRAP><NOBR>$fnt1";
$mid="</FONT></NOBR></TD><TD BGCOLOR=$c5 NOWRAP><NOBR>$fnt";
$end="</FONT></NOBR></TD></TR>\n";

($pverx=$])=~s/^(\d+)(\.\d+)$/$1$2/;
$pver="$1";
$patch=($2*1000);
$patch=~s/\D//g;
$pver.=".$patch";
$osc="($^O OS compile version)" if ($^O);
$perlversion="$pver $osc";
$sendmail=`whereis sendmail`; $sendmail=~s/sendmail://;
@mailpath=split(" ",$sendmail);
 foreach $sml(@mailpath) {$mailpath.="$sml<BR>" if ($sml=~/sendmail$/i);
}
$qmail=`whereis qmail`; $qmail=~s/qmail://;
@qmailpath=split(" ",$qmail);
 foreach $qml(@qmailpath) {$qmailpath.="$qml<BR>" if ($qml=~/qmail$/i);
}

$ppath=`whereis perl`; $ppath=~s/perl: //;
@perlpath=split(" ",$ppath);
 foreach $pth(@perlpath) {$perlpath.="$pth<BR>" if ($pth=~/perl$/i);
}

##########
# ACCESS SUBROUTINE

if ($secure eq 1) {&access;}

sub access {

if ($ipaddress !~ /$ENV{REMOTE_ADDR}/) {
print "Location:http://www.CraigRichards.com/restricted.html?ref=$ENV{SERVER_NAME}&v=$v\n\n";
exit;
 } else {$secflag="<FONT SIZE=2 COLOR=$c1><B><NOBR>restricted</B></FONT><BR>\nuser&nbsp;IP:&nbsp;$ENV{REMOTE_ADDR}</NOBR>";}
}


##########
# PRINT ENVIRONMENTAL VARIABLES

print "Content-type: text/html\n\n";

# include other very helpful variables even if empty:

$ENV{"HTTP_COOKIE"}="&nbsp;" unless ($ENV{HTTP_COOKIE});
$ENV{"PATH_INFO"}="&nbsp;" unless ($ENV{PATH_INFO});
$ENV{"REDIRECT_ERROR_NOTES"}="&nbsp;" unless ($ENV{REDIRECT_ERROR_NOTES});
$ENV{"REDIRECT_REQUEST_METHOD"}="&nbsp;" unless ($ENV{REDIRECT_REQUEST_METHOD});
$ENV{"REDIRECT_STATUS"}="&nbsp;" unless ($ENV{REDIRECT_STATUS});
$ENV{"REDIRECT_UNIQUE_ID"}="&nbsp;" unless ($ENV{REDIRECT_UNIQUE_ID});
$ENV{"REDIRECT_URL"}="&nbsp;" unless ($ENV{REDIRECT_URL});
$ENV{"REDIRECT_nokeepalive"}="&nbsp;" unless ($ENV{REDIRECT_nokeepalive});
$ENV{"REDIRECT_ssl_unclean_shutdown"}="&nbsp;" unless ($ENV{REDIRECT_ssl_unclean_shutdown});
$ENV{"TZ"}="&nbsp;" unless ($ENV{TZ});
$ENV{"USER_ID"}="&nbsp;" unless ($ENV{USER_ID});
$ENV{"USER_NAME"}="&nbsp;" unless ($ENV{USER_NAME});
$ENV{"UNIQUE_ID"}="&nbsp;" unless ($ENV{UNIQUE_ID});

foreach $key(sort keys %ENV){
 $ENV{$key}="&nbsp;" if (!$ENV{$key});
 if ($key eq "HTTP_COOKIE"){
  @cookies=split("; ",$ENV{HTTP_COOKIE});
  foreach $cookie(@cookies){
   $ckcnt++;
   if ($ck){
    $ck.="<BR><FONT SIZE=1 COLOR=#909090><SUP>$ckcnt</SUP></FONT> $cookie";
   } else {
    $ck="<FONT SIZE=1 COLOR=#909090><SUP>$ckcnt</SUP></FONT> $cookie";
   }
  }
  $ENV{$key}=$ck if ($ck);
 }
 push(@envirolyzers,"$row$key$mid$ENV{$key}$end\n");
}
$mail.="$row PATH TO SENDMAIL$mid $mailpath $end\n" if ($mailpath);
$mail.="$row PATH TO QMAIL$mid $qmailpath $end\n" if ($qmailpath);

print<<EOF;
<HTML><HEAD><TITLE>Envirolyzer $version by Craig Richards</TITLE>
</SCRIPT>
<STYLE TYPE="text/css">
	A {text-decoration:underline; color:$c2}
	A:link {text-decoration:underline; color:$c2}
	A:visited {text-decoration:underline; color:$c1;}
	A:active {text-decoration:none; color:$c1; background-color:$c7;}
	A:hover {text-decoration:none; color:$c1; background-color:$c7;}
</STYLE>
</HEAD>
<BODY BGCOLOR=$c6 MARGINWIDTH=12 MARGINHEIGHT=6 LEFTMARGIN=12 RIGHTMARGIN=12 TOPMARGIN=6 BOTTOMMARGIN=6 TEXT=000000 LINK=$c2 ALINK=FF0000 VLINK=$c1><BASEFONT SIZE=2>$fnt1

<CENTER><TABLE WIDTH=200 BGCOLOR=$c1 CELLPADDING=2 CELLSPACING=0 BORDER=0><TR ALIGN=CENTER VALIGN=MIDDLE><TD><TABLE WIDTH=100% BGCOLOR=$c3 CELLPADDING=2 CELLSPACING=1 BORDER=0>
<TR VALIGN=BOTTOM><TD NOWRAP><NOBR>$fnt1 access is $secflag
</NOBR></TD><TD WIDTH=100% ALIGN=CENTER NOWRAP><NOBR>$fnt1<A HREF="http://www.CraigRichards.com/software/?v=$v" onMouseOver="window.status='click here to go to Craig Richards Design now'; return true;" onMouseOut="window.status=''; return true;" TITLE="click here to go to Craig&nbsp;Richards Design"><IMG SRC="http://www.CraigRichards.com/images/envirolyzer-122.gif" WIDTH=96 HEIGHT=21 ALIGN=MIDDLE BORDER=0 ALT="Envirolyzer"></A> $version</NOBR></TD><TD ALIGN=RIGHT>$fnt1<FONT COLOR=#909090><NOBR>&copy; Copyright 2003 Craig Richards Design.</NOBR> <NOBR>All rights reserved worldwide.
</NOBR></FONT></TD></TR></TABLE>
<TABLE WIDTH=100% BGCOLOR=$c3 CELLPADDING=2 CELLSPACING=1 BORDER=0>
<TR ALIGN=CENTER VALIGN=TOP><TD COLSPAN=2>$fnt &nbsp;<BR>
<B>Envirolyzer</B> reports its analysis of server and client environments<BR>
to help streamline your authoring and programming tasks.<BR>
&nbsp;$end
$row PERL VERSION$mid $perlversion $end
$row PATH TO PERL$mid $perlpath $end
$mail
@envirolyzers
<TR ALIGN=RIGHT><TD COLSPAN=2 NOWRAP>$fnt1<FONT COLOR=#909090>by <A HREF="http://www.CraigRichards.com/software/" onMouseOver="window.status='click here to go to Craig Richards Design now'; return true;" onMouseOut="window.status=''; return true;" TITLE="click here to go to Craig&nbsp;Richards Design now">Craig&nbsp;Richards&nbsp;Design</A>$end
</TABLE></TD></TR></TABLE></CENTER>
</BODY></HTML>

EOF

1;
exit;
